searchNodes=[{"doc":"Req is an HTTP client with a focus on ease of use and composability, built on top of Finch . This is a work in progress! Features Extensibility via request, response, and error steps Automatic body decompression (via decompress/2 step) Automatic body encoding and decoding (via encode/1 and decode/2 steps) Encode params as query string (via params/2 step) Basic authentication (via auth/2 step) .netrc file support (via netrc/2 step) Range requests (via range/2 step) Follows redirects (via follow_redirects/2 step) Retries on errors (via retry/3 step) Basic HTTP caching (via if_modified_since/2 step) Usage The easiest way to use Req is with Mix.install/2 (requires Elixir v1.12+): Mix . install ( [ { :req , &quot;~&gt; 0.1.0-dev&quot; , github : &quot;wojtekmach/req&quot; , branch : &quot;main&quot; } ] ) Req . get! ( &quot;https://api.github.com/repos/elixir-lang/elixir&quot; ) . body [ &quot;description&quot; ] #=&gt; &quot;Elixir is a dynamic, functional language designed for building scalable and maintainable applications&quot; If you want to use Req in a Mix project, you can add the above dependency to your mix.exs. Low-level API Under the hood, Req works by passing a request through a series of steps. The request struct, %Req.Request{} , initially contains data like HTTP method and request headers. You can also add request, response, and error steps to it. Request steps are used to refine the data that will be sent to the server. After making the actual HTTP request, we'll either get a HTTP response or an error. The request, along with the response or error, will go through response or error steps, respectively. Nothing is actually executed until we run the pipeline with Req.run/1 . Example: Req . build ( :get , &quot;https://api.github.com/repos/elixir-lang/elixir&quot; ) |&gt; Req . prepend_request_steps ( [ &amp; Req . default_headers / 1 ] ) |&gt; Req . prepend_response_steps ( [ &amp; Req . decode / 2 ] ) |&gt; Req . run ( ) #=&gt; {:ok, %{body: %{&quot;description&quot; =&gt; &quot;Elixir is a dynamic,&quot; &lt;&gt; ...}, ...}, ...} The high-level API shown before: Req . get! ( &quot;https://api.github.com/repos/elixir-lang/elixir&quot; ) is equivalent to this composition of lower-level API functions: Req . build ( :get , &quot;https://api.github.com/repos/elixir-lang/elixir&quot; ) |&gt; Req . prepend_default_steps ( ) |&gt; Req . run! ( ) (See Req.build/3 , Req.prepend_default_steps/2 , and Req.run!/1 for more information.) We can also build more complex flows like returning a response from a request step or an error from a response step. We will explore those next. Request steps A request step is a function that accepts a request and returns one of the following: A request A {request, response_or_error} tuple. In that case no further request steps are executed and the return value goes through response or error steps Examples: def default_headers ( request ) do update_in ( request . headers , &amp; [ { &quot;user-agent&quot; , &quot;req/0.1.0-dev&quot; } | &amp;1 ] ) end def read_from_cache ( request ) do case ResponseCache . fetch ( request ) do { :ok , response } -&gt; { request , response } :error -&gt; request end end Response and error steps A response step is a function that accepts a request and a response and returns one of the following: A {request, response} tuple A {request, exception} tuple. In that case, no further response steps are executed but the exception goes through error steps Similarly, an error step is a function that accepts a request and an exception and returns one of the following: A {request, exception} tuple A {request, response} tuple. In that case, no further error steps are executed but the response goes through response steps Examples: def decode ( request , response ) do case List . keyfind ( response . headers , &quot;content-type&quot; , 0 ) do { _ , &quot;application/json&quot; &lt;&gt; _ } -&gt; { request , update_in ( response . body , &amp; Jason . decode! / 1 ) } _ -&gt; { request , response } end end def log_error ( request , exception ) do Logger . error ( [ &quot; \#{ request . method } \#{ request . url } : &quot; , Exception . message ( exception ) ] ) { request , exception } end Halting Any step can call Req.Request.halt/1 to halt the pipeline. This will prevent any further steps from being invoked. Examples: def circuit_breaker ( request ) do if CircuitBreaker . open? ( ) do { Req.Request . halt ( request ) , RuntimeError . exception ( &quot;circuit breaker is open&quot; ) } else request end end","ref":"Req.html","title":"Req","type":"module"},{"doc":"Appends error steps.","ref":"Req.html#append_error_steps/2","title":"Req.append_error_steps/2","type":"function"},{"doc":"Appends request steps.","ref":"Req.html#append_request_steps/2","title":"Req.append_request_steps/2","type":"function"},{"doc":"Appends response steps.","ref":"Req.html#append_response_steps/2","title":"Req.append_response_steps/2","type":"function"},{"doc":"Sets request authentication. auth can be one of: {username, password} - uses Basic HTTP authentication Examples iex&gt; Req . get! ( &quot;https://httpbin.org/basic-auth/foo/bar&quot; , auth : { &quot;bad&quot; , &quot;bad&quot; } ) . status 401 iex&gt; Req . get! ( &quot;https://httpbin.org/basic-auth/foo/bar&quot; , auth : { &quot;foo&quot; , &quot;bar&quot; } ) . status 200","ref":"Req.html#auth/2","title":"Req.auth/2","type":"function"},{"doc":"Builds a request pipeline. Options :header - request headers, defaults to [] :body - request body, defaults to &quot;&quot; :finch - Finch pool to use, defaults to Req.Finch which is automatically started by the application. See Finch module documentation for more information on starting pools. :finch_options - Options passed down to Finch when making the request, defaults to [] . See Finch.request/3 for more information.","ref":"Req.html#build/3","title":"Req.build/3","type":"function"},{"doc":"Decodes response body based on the detected format. Supported formats: Format Decoder json Jason.decode!/1 gzip :zlib.gunzip/1 tar :erl_tar.extract/2 zip :zip.unzip/2 csv NimbleCSV.RFC4180.parse_string/2 (if NimbleCSV is installed) Examples iex&gt; Req . get! ( &quot;https://hex.pm/api/packages/finch&quot; ) . body [ &quot;meta&quot; ] %{ &quot;description&quot; =&gt; &quot;An HTTP client focused on performance.&quot; , &quot;licenses&quot; =&gt; [ &quot;MIT&quot; ] , &quot;links&quot; =&gt; %{ &quot;GitHub&quot; =&gt; &quot;https://github.com/keathley/finch&quot; } , ... }","ref":"Req.html#decode/2","title":"Req.decode/2","type":"function"},{"doc":"Decompresses the response body based on the content-encoding header. Examples iex&gt; response = Req . get! ( &quot;https://httpbin.org/gzip&quot; ) iex&gt; response . headers [ { &quot;content-encoding&quot; , &quot;gzip&quot; } , { &quot;content-type&quot; , &quot;application/json&quot; } , ... ] iex&gt; response . body %{ &quot;gzipped&quot; =&gt; true , ... }","ref":"Req.html#decompress/2","title":"Req.decompress/2","type":"function"},{"doc":"Adds common request headers. Currently the following headers are added: &quot;user-agent&quot; - &quot;req/0.1.0&quot; &quot;accept-encoding&quot; - &quot;gzip&quot;","ref":"Req.html#default_headers/1","title":"Req.default_headers/1","type":"function"},{"doc":"Encodes the request body based on its shape. If body is of the following shape, it's encoded and its content-type set accordingly. Otherwise it's unchanged. Shape Encoder Content-Type {:form, data} URI.encode_query/1 &quot;application/x-www-form-urlencoded&quot; {:json, data} Jason.encode_to_iodata!/1 &quot;application/json&quot; Examples iex&gt; Req . post! ( &quot;https://httpbin.org/post&quot; , { :form , comments : &quot;hello!&quot; } ) . body [ &quot;form&quot; ] %{ &quot;comments&quot; =&gt; &quot;hello!&quot; }","ref":"Req.html#encode/1","title":"Req.encode/1","type":"function"},{"doc":"Follows redirects. Examples iex&gt; Req . get! ( &quot;http://api.github.com&quot; ) . status # 23:24:11.670 [debug] Req.follow_redirects/2: Redirecting to https://api.github.com/ 200","ref":"Req.html#follow_redirects/2","title":"Req.follow_redirects/2","type":"function"},{"doc":"Makes a GET request. See request/3 for a list of supported options.","ref":"Req.html#get!/2","title":"Req.get!/2","type":"function"},{"doc":"Handles HTTP cache using if-modified-since header. Only successful (200 OK) responses are cached. This step also prepends a response step that loads and writes the cache. Be careful when prepending other response steps, make sure the cache is loaded/written as soon as possible. Options :dir - the directory to store the cache, defaults to &lt;user_cache_dir&gt;/req (see: :filename.basedir/3 ) Examples iex&gt; url = &quot;https://hexdocs.pm/elixir/Kernel.html&quot; iex&gt; response = Req . get! ( url , cache : true ) %{ status : 200 , headers : [ { &quot;date&quot; , &quot;Fri, 16 Apr 2021 10:09:56 GMT&quot; } , ... ] , ... } iex&gt; Req . get! ( url , cache : true ) == response true","ref":"Req.html#if_modified_since/2","title":"Req.if_modified_since/2","type":"function"},{"doc":"Sets request authentication for a matching host from a netrc file. Examples iex&gt; Req . get! ( &quot;https://httpbin.org/basic-auth/foo/bar&quot; ) . status 401 iex&gt; Req . get! ( &quot;https://httpbin.org/basic-auth/foo/bar&quot; , netrc : true ) . status 200 iex&gt; Req . get! ( &quot;https://httpbin.org/basic-auth/foo/bar&quot; , netrc : &quot;/path/to/custom_netrc&quot; ) . status 200","ref":"Req.html#netrc/2","title":"Req.netrc/2","type":"function"},{"doc":"Normalizes request headers. Turns atom header names into strings, e.g.: :user_agent becomes &quot;user-agent&quot; . Non-atom names are returned as is. Examples iex&gt; Req . get! ( &quot;https://httpbin.org/user-agent&quot; , headers : [ user_agent : &quot;my_agent&quot; ] ) . body %{ &quot;user-agent&quot; =&gt; &quot;my_agent&quot; }","ref":"Req.html#normalize_headers/1","title":"Req.normalize_headers/1","type":"function"},{"doc":"Adds params to request query string. Examples iex&gt; Req . get! ( &quot;https://httpbin.org/anything/query&quot; , params : [ x : &quot;1&quot; , y : &quot;2&quot; ] ) . body [ &quot;args&quot; ] %{ &quot;x&quot; =&gt; &quot;1&quot; , &quot;y&quot; =&gt; &quot;2&quot; }","ref":"Req.html#params/2","title":"Req.params/2","type":"function"},{"doc":"Makes a POST request. See request/3 for a list of supported options.","ref":"Req.html#post!/3","title":"Req.post!/3","type":"function"},{"doc":"Prepends steps that should be reasonable defaults for most users. Request steps normalize_headers/1 default_headers/1 encode/1 &amp;netrc(&amp;1, options[:netrc]) (if options[:netrc] is set to an atom true for default path or a string for custom path) &amp;auth(&amp;1, options[:auth]) (if options[:auth] is set to) &amp;params(&amp;1, options[:params]) (if options[:params] is set) &amp;range(&amp;1, options[:range]) (if options[:range] is set) Response steps &amp;retry(&amp;1, &amp;2, options[:retry]) (if options[:retry] is set to an atom true or a options keywords list) follow_redirects/2 decompress/2 decode/2 Error steps &amp;retry(&amp;1, &amp;2, options[:retry]) (if options[:retry] is set and is a keywords list or an atom true ) Options :netrc - if set, adds the netrc/2 step :auth - if set, adds the auth/2 step :params - if set, adds the params/2 step :range - if set, adds the range/2 step :cache - if set to true , adds if_modified_since/2 step :raw if set to true , skips decompress/2 and decode/2 steps :retry - if set, adds the retry/3 step to response and error steps","ref":"Req.html#prepend_default_steps/2","title":"Req.prepend_default_steps/2","type":"function"},{"doc":"Prepends error steps.","ref":"Req.html#prepend_error_steps/2","title":"Req.prepend_error_steps/2","type":"function"},{"doc":"Prepends request steps.","ref":"Req.html#prepend_request_steps/2","title":"Req.prepend_request_steps/2","type":"function"},{"doc":"Prepends response steps.","ref":"Req.html#prepend_response_steps/2","title":"Req.prepend_response_steps/2","type":"function"},{"doc":"Sets the &quot;Range&quot; request header. range can be one of the following: a string - returned as is a first..last range - converted to &quot;bytes=&lt;first&gt;-&lt;last&gt;&quot; Examples iex&gt; Req . get! ( &quot;https://repo.hex.pm/builds/elixir/builds.txt&quot; , range : 0 .. 67 ) %{ status : 206 , headers : [ { &quot;content-range&quot; , &quot;bytes 0-67/45400&quot; } , ... ] , body : &quot;master df65074a8143cebec810dfb91cafa43f19dcdbaf 2021-04-23T15:36:18Z&quot; }","ref":"Req.html#range/2","title":"Req.range/2","type":"function"},{"doc":"Makes an HTTP request. Options :headers - request headers, defaults to [] :body - request body, defaults to &quot;&quot; :finch - Finch pool to use, defaults to Req.Finch which is automatically started by the application. See Finch module documentation for more information on starting pools. :finch_options - Options passed down to Finch when making the request, defaults to [] . See Finch.request/3 for more information. The options are passed down to prepend_default_steps/2 , see its documentation for more information how they are being used.","ref":"Req.html#request/3","title":"Req.request/3","type":"function"},{"doc":"Makes an HTTP request and returns a response or raises an error. See request/3 for more information.","ref":"Req.html#request!/3","title":"Req.request!/3","type":"function"},{"doc":"Retries a request in face of errors. This function can be used as either or both response and error step. It retries a request that resulted in: a response with status 5xx an exception Options :delay - sleep this number of milliseconds before making another attempt, defaults to 2000 :max_attempts - maximum number of retry attempts, defaults to 2 (for a total of 3 requests to the server, including the initial one.) Examples With default options: iex&gt; Req . get! ( &quot;https://httpbin.org/status/500,200&quot; , retry : true ) . status # 19:02:08.463 [error] Req.retry/3: Got response with status 500. Will retry in 2000ms, 2 attempts left # 19:02:10.710 [error] Req.retry/3: Got response with status 500. Will retry in 2000ms, 1 attempt left 200 With custom options: iex&gt; Req . get! ( &quot;http://localhost:9999&quot; , retry : [ delay : 100 , max_attempts : 3 ] ) # 17:00:38.371 [error] Req.retry/3: Got exception. Will retry in 100ms, 3 attempts left # 17:00:38.371 [error] ** (Mint.TransportError) connection refused # 17:00:38.473 [error] Req.retry/3: Got exception. Will retry in 100ms, 2 attempts left # 17:00:38.473 [error] ** (Mint.TransportError) connection refused # 17:00:38.575 [error] Req.retry/3: Got exception. Will retry in 100ms, 1 attempt left # 17:00:38.575 [error] ** (Mint.TransportError) connection refused ** (Mint.TransportError) connection refused","ref":"Req.html#retry/3","title":"Req.retry/3","type":"function"},{"doc":"Runs a request pipeline. Returns {:ok, response} or {:error, exception} .","ref":"Req.html#run/1","title":"Req.run/1","type":"function"},{"doc":"Runs a request pipeline and returns a response or raises an error. See run/1 for more information.","ref":"Req.html#run!/1","title":"Req.run!/1","type":"function"},{"doc":"The Request pipeline struct. Fields: :method - the HTTP request method :uri - the HTTP request URI :headers - the HTTP request headers :body - the HTTP request body :halted - whether the request pipeline is halted. See halt/1 :request_steps - the list of request steps :response_steps - the list of response steps :error_steps - the list of error steps :private - a map reserved for libraries and frameworks to use. Prefix the keys with the name of your project to avoid any future conflicts.","ref":"Req.Request.html","title":"Req.Request","type":"module"},{"doc":"Gets the value for a specific private key .","ref":"Req.Request.html#get_private/3","title":"Req.Request.get_private/3","type":"function"},{"doc":"Halts the request pipeline preventing any further steps from executing.","ref":"Req.Request.html#halt/1","title":"Req.Request.halt/1","type":"function"},{"doc":"Assigns a private key to value .","ref":"Req.Request.html#put_private/3","title":"Req.Request.put_private/3","type":"function"},{"doc":"CHANGELOG","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"Initial release","ref":"changelog.html#v0-1-0-2021-07-15","title":"CHANGELOG - v0.1.0 (2021-07-15)","type":"extras"}]